ZOJ2913Bus Pass(BFS+set)

Bus Pass


Time Limit: 5 Seconds      Memory Limit: 32768 KB


You travel a lot by bus and the costs of all the seperate tickets are starting to add up.

Therefore you want to see if it might be advantageous for you to buy a bus pass.

The way the bus system works in your country (and also in the Netherlands) is as follows:

when you buy a bus pass, you have to indicate a center zone and a star value. You are allowed to travel freely in any zone which has a distance to your center zone which is less than your star value. For example, if you have a star value of one, you can only travel in your center zone. If you have a star value of two, you can also travel in all adjacent zones, et cetera.

You have a list of all bus trips you frequently make, and would like to determine the minimum star value you need to make all these trips using your buss pass. But this is not always an easy task. For example look at the following figure:

Here you want to be able to travel from A to B and from B to D. The best center zone is 7400, for which you only need a star value of 4. Note that you do not even visit this zone on your trips!

Input

On the first line an integert(1 <=t<= 100): the number of test cases. Then for each test case:

One line with two integersnz(2 <=nz<= 9 999) andnr(1 <=nr<= 10): the number of zones and the number of bus trips, respectively.

nz lines starting with two integers idi (1 <= idi <= 9 999) and mzi (1 <= mzi <= 10), a number identifying the i-th zone and the number of zones adjacent to it, followed by mzi integers: the numbers of the adjacent zones.

nr lines starting with one integer mri (1 <= mri <= 20), indicating the number of zones the ith bus trip visits, followed by mri integers: the numbers of the zones through which the bus passes in the order in which they are visited.

All zones are connected, either directly or via other zones.

Output

For each test case:

One line with two integers, the minimum star value and the id of a center zone which achieves this minimum star value. If there are multiple possibilities, choose the zone with the lowest number.

Sample Input

1
17 2
7400 6 7401 7402 7403 7404 7405 7406
7401 6 7412 7402 7400 7406 7410 7411
7402 5 7412 7403 7400 7401 7411
7403 6 7413 7414 7404 7400 7402 7412
7404 5 7403 7414 7415 7405 7400
7405 6 7404 7415 7407 7408 7406 7400
7406 7 7400 7405 7407 7408 7409 7410 7401
7407 4 7408 7406 7405 7415
7408 4 7409 7406 7405 7407
7409 3 7410 7406 7408
7410 4 7411 7401 7406 7409
7411 5 7416 7412 7402 7401 7410
7412 6 7416 7411 7401 7402 7403 7413
7413 3 7412 7403 7414
7414 3 7413 7403 7404
7415 3 7404 7405 7407
7416 2 7411 7412
5 7409 7408 7407 7405 7415
6 7415 7404 7414 7413 7412 7416

Sample Output

4 7400

参考:http://blog.csdn.net/acvay/article/details/40221819

题意:从给的公交线路(nr)找到一个中心,这个中心到每一个公交车站距离最优即(这个中心顾及到每个公交车站)。并求出这个中心到其中一个公交车站最远距离。

思路:对每一个公交车站进行BFS求出dis[i],i这个点到这些公交车站最远距离。

收获:1.了解了set:每个元素最多只出现一次,并且默认的是从小到大排序。

2.set<int>::iterator 从set中将编号取出来。

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<iostream>
 4 #include<algorithm>
 5 #include<queue>
 6 #include<set>
 7 using namespace std;
 8 #define maxn 10000
 9 typedef set<int>::iterator it;
10 set<int>zone;
11 int link[maxn][12];
12 int dis[maxn],tdis[maxn];
13 void bfs(int st)
14 {
15     queue<int>q;
16     memset(tdis,0,sizeof(tdis));
17     tdis[st]=1;
18     q.push(st);
19     while(!q.empty())
20     {
21         int cur=q.front();
22         q.pop();
23         if(tdis[cur]>dis[cur])
24             dis[cur]=tdis[cur];
25         for(int i=1;i<=link[cur][0];i++)
26         {
27             int temp=link[cur][i];
28             if(tdis[temp]==0)
29             {
30                 q.push(temp);
31             tdis[temp]=tdis[cur]+1;
32             }
33         }
34     }
35
36 }
37 int main()
38 {
39     int t;
40     scanf("%d",&t);
41     while(t--)
42     {
43         zone.clear();
44         int nz,nr,mz,mr,num,id;
45         scanf("%d%d",&nz,&nr);
46         for(int i=0;i<nz;i++)
47         {
48             scanf("%d%d",&id,&mz);
49             link[id][0]=mz;
50             for(int j=1;j<=mz;j++)
51             {
52                 scanf("%d",&link[id][j]);
53                 zone.insert(link[id][j]);
54             }
55         }
56         int pos;
57         memset(dis,0,sizeof(tdis));
58         for(int i=0;i<nr;i++)
59         {
60             scanf("%d",&mr);
61             for(int j=0;j<mr;j++)
62                 {
63                     scanf("%d",&pos);
64                     bfs(pos);
65                 }
66         }
67         it i=zone.begin();
68         int ans= *i;
69         for(++i;i!=zone.end();++i)
70             if(dis[*i]<dis[ans])
71             ans=*i;
72         printf("%d %d\n",dis[ans],ans);
73     }
74     return 0;
75 }
时间: 2024-10-13 00:14:06

ZOJ2913Bus Pass(BFS+set)的相关文章

Zoj 2913 Bus Pass BFS

题意: 给你一张图,和一些指定的点,找一个点使得这些指定的点到这个点的距离的最大值最小 对每一个指定的点都做一遍BFS,更新到达每个点的距离,取较大值,然后扫一遍所有的点,找出最小即可. 注意:不同于走格子,因为方向比较多,所以要在扩展节点的时候就更新vis数组,不然有可能导致某个点的距离因为重复更新而不是最小值. 并且不要漏了一开始就更新起点的vis #include <cstdio> #include <vector> #include <cstring> #inc

Bus Pass BFS搜索

Bus Pass 题目抽象:给出nz个点组成的连通图,给出每个点的连接顶点.给出nr条路径.要求找出某点,使得到达每条路径上的每个顶点的距离的最大值最小. 分析:以每条路径上的顶点为起点,bfs搜索.具体见代码. 1 /******************************** 2 please don't hack me!! /(ToT)/~~ 3 __------__ 4 /~ ~ 5 | //^\\//^\| 6 /~~\ || T| |T|:~ 7 | |6 ||___|_|_||

ACM/ICPC 之 BFS范例(ZOJ2913)

通过一道经典BFS例题阐述BFS思路 ZOJ2913-Bus Pass 题意:找一个center区域,使得center到所有公交线路最短,有等距的center则输出id最小的. 题解:经典的BFS,由公交线路最多只经过10*20个区域,而总区域数可达10^5个,因此应该从公交线路通过队列一层层向外扩展,最后判断一次center的位置即可. 1 //选定一个center使得其到所有公交线路最短 2 //对所有公交线路进行BFS(公交线路比其他区域少得多) 3 //Time:150Ms Memory

ZOJ 2913 Bus Pass (最近的最远BFS HDU2377)

题意  在所有城市中找一个中心满足这个中心到所有公交站点距离的最大值最小 输出最小距离和满足最小距离编号最小的中心 最基础的BFS  对每个公交站点BFS  dis[i]表示编号为i的点到所有公交站点距离的最大值  bfs完所有站点后  dis[i]最小的点就是要求的点咯 #include<cstdio> #include<cstring> #include<queue> #include<set> using namespace std; typedef

zoj 2913 Bus Pass (BFS)

Bus Pass Time Limit: 5 Seconds      Memory Limit: 32768 KB You travel a lot by bus and the costs of all the seperate tickets are starting to add up. Therefore you want to see if it might be advantageous for you to buy a bus pass. The way the bus syst

hdu 5094 Maze bfs+状态压缩

Maze Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 100000/100000 K (Java/Others) Total Submission(s): 642    Accepted Submission(s): 229 Problem Description This story happened on the background of Star Trek. Spock, the deputy captain of St

HDU - 2612 - Find a way (BFS)

Find a way Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 6157    Accepted Submission(s): 2052 Problem Description Pass a year learning in Hangzhou, yifenfei arrival hometown Ningbo at finally

hdu 1026 Ignatius and the Princess I (bfs打印路径)

Problem Description The Princess has been abducted by the BEelzebub feng5166, our hero Ignatius has to rescue our pretty Princess. Now he gets into feng5166's castle. The castle is a large labyrinth. To make the problem simply, we assume the labyrint

Bus Pass

ZOJ Problem Set - 2913 Time Limit: 5 Seconds      Memory Limit: 32768 KB You travel a lot by bus and the costs of all the seperate tickets are starting to add up. Therefore you want to see if it might be advantageous for you to buy a bus pass. The wa